
ECHO ON
// EXTRAS.FOR
ECHO OFF
RUNTIME  
0 'LFA FORTH LFA>CA BPW 3 *  + !
 FORGET PATCHIT
4000 GETMEM DROP
// ECHO ON
RUNTIME FORTH DEFINITIONS
: RAM>FILE                   ( // &MODDATA -- )
	RAM DSTACK RAM - 
	>FILE               ( FP -- )
;

: 128K>FILE                   ( // &MODDATA -- )
	100000 20000 
	>FILE               ( FP -- )
;

 RUNTIME
 COMPILER
 ' [CON] ' CONSTANT  10 + !
 ' [VAR] ' VARIABLE  10 + !
 ' [LAB] ' LABEL  10 + !
 ' [LIT] ' LITERAL  8 + !
 ' [DO]  ' DO  8 + !
 ' [LOOP] ' LOOP  8 + !
 ' [IF]  ' IF  8 + !
 ' [ABORT]  ' ABORT"  20 + !
HERE 4000 ERASE
 
COMPILER DEFINITIONS

// If alias is used before the relocation then it points to the old copy.
ALIAS WHILE	IF	// While does the same as IF
IMMEDIATE

: UNTIL 
	[ 'LFA [IF] LFA>CA LITERAL ] BRLNK
	BR
; IMMEDIATE


RUNTIME DEFINITIONS 
 
FFFFFC10 CONSTANT PMC_PCER // (PMC) Peripheral Clock Enable Register
2 CONSTANT ID_PIOA     // Parallel IO Controller bit
6 CONSTANT ID_US0      // USART 0
7 CONSTANT ID_US1      // USART 0
 // ========== Register definition for usart peripheral ==========

1 2 LSHIFT CONSTANT US_RSTRX // (DBGU) Reset Receiver
1 3 LSHIFT CONSTANT US_RSTTX // (DBGU) Reset Transmitter
1 4 LSHIFT CONSTANT US_RXEN  // (DBGU) Receiver Enable
1 5 LSHIFT CONSTANT US_RXDIS // (DBGU) Receiver Disable
1 6 LSHIFT CONSTANT US_TXEN  // (DBGU) Transmitter Enable
1 7 LSHIFT CONSTANT US_TXDIS // (DBGU) Transmitter Disable
1 8 LSHIFT CONSTANT RSTSTA   // (DBGU) Reset Status Bits

// ========== Register definition for PIOA peripheral ==========
FFFFF404 CONSTANT PIOA_PDR   // (PIOA) PIO Disable Register
DECIMAL
1 21 LSHIFT CONSTANT PA21_RXD1 
1 22 LSHIFT CONSTANT PA22_TXD1 

0 CONSTANT US_USMODE_NORMAL  // (USART) Normal
0 4 LSHIFT  CONSTANT US_CLKS_CLOCK    // (USART) Clock
0 12 LSHIFT CONSTANT US_NBSTOP_1_BIT  // (USART) 1 stop bit
4 9 LSHIFT  CONSTANT US_PAR_NONE      // (DBGU) No Parity
3 6 LSHIFT  CONSTANT US_CHRL_8_BITS   // (USART) Character Length: 8 bit
HEX

FFFFFD00  	CONSTANT base_RSTC		
8	  		CONSTANT RSTC_MR 		
1  			CONSTANT RSTC_URSTEN

LABEL INIDATA // Data to initialize uart etc

//   Enable RxD0 Pin  Enable TxD0 Pin */
// PIOA_PDR , PA21_RXD1 PA22_TXD1 OR ,
// PIOA_PDR , 600063 ,

// set up usart 0
// Reset Receiver Reset Transmitter  Receiver Disable  Transmitter Disable 
BASE_US0 , US_RSTRX US_RSTTX US_RXDIS US_TXDIS OR OR OR , // same as US_CR 

// Normal Mode Clock = MCK No Parity 1 Stop Bit 
BASE_US0 US_MR + , US_USMODE_NORMAL US_CLKS_CLOCK US_CHRL_8_BITS US_PAR_NONE US_NBSTOP_1_BIT OR OR OR OR ,

//  Baud Rate Divisor 38.4Kbd with 48mhz clock = 78, 115 = 26

BASE_US0 US_BRGR + , DECIMAL 26 HEX ,

//  Receiver Enable  Transmitter Enable  
BASE_US0 , US_RXEN US_TXEN OR ,

// set up usart 1
// Reset Receiver Reset Transmitter  Receiver Disable  Transmitter Disable 
BASE_US1 , US_RSTRX US_RSTTX US_RXDIS US_TXDIS OR OR OR , // same as US_CR 

// Normal Mode Clock = MCK No Parity 1 Stop Bit 
BASE_US1 US_MR + , US_USMODE_NORMAL US_CLKS_CLOCK US_CHRL_8_BITS US_PAR_NONE US_NBSTOP_1_BIT OR OR OR OR ,


//  Baud Rate Divisor 38.4Kbd with 48mhz clock = 78, 115 = 26

BASE_US1 US_BRGR + , DECIMAL 26 HEX ,

//  Receiver Enable  Transmitter Enable  
BASE_US1 , US_RXEN US_TXEN OR ,

//  p_pPMC->PMC_PCER = 1 << AT91C_ID_PIOA;
PMC_PCER , 1 ID_PIOA LSHIFT 1 ID_US0 LSHIFT 1 ID_US1 LSHIFT OR OR ,

//  p_pPio->PIO_PER = BIT8;    //Enable PA8 for led
PIO_PER	,	LEDBIT ,

//  p_pPio->PIO_OER = BIT8;    //Configure in Output
PIO_OER , INITOER ,
PIO_OER-B , INITOER-B ,						

// *AT91C_RSTC_RMR = 0xA5000000|AT91C_RSTC_URSTEN ;
base_RSTC RSTC_MR + , A5000000 RSTC_URSTEN OR ,
0 ,

: INITPORTS
// FFFFF240 - ID :  275 = X 270 = S

	FFFFF240 @ // Get chip ID
	FFF00000 AND 
	27500000 = IF // X256
		63
	ELSE
		600060
	THEN
	PIOA_PDR !
	
	INIDATA
	BEGIN
		DUP @ // While not pointing to a zero
	WHILE
		 DUP 4 + @ 		// PTR, DATA -- 
		 OVER @			// PTR, DATA STOREADDR -- 
			! 
		 8 + 
	REPEAT
	DROP
;

COMPILER
HERE .
// reset vector points here. Probably running in flash with nothing initialized yet.
CREATE BOOT // Use create instead of : to avoid stack push before ram is up.
 ] RESET // intialize arm memory controls, clock etc.
	INITPORTS	// bring up coms and io ports.
	4 0 DO LEDON DELAY LEDOFF DELAY LOOP // show some life.
	LR@
	RAM <
	IF
		FREETOP 100000 - FREETOP DSTACK OVER - CMOVE 
		100000 200000 DP @ OVER - CMOVE 
	THEN
	*COLD @ EXECUTE // run forth 
 [ // no need for ; because abort never returns here.

' BOOT 100000 - 200020 !
' BOOT 100000 - 200024 !
' BOOT 100000 - 200028 !
' BOOT 100000 - 20002C !
' BOOT 100000 - 200030 !
' BOOT 100000 - 200034 !
' BOOT 100000 - 200038 !
' BOOT 100000 - 20003C !

: SDASC
	OVER OVER SWAP
	OVER OVER -
	IF SPACE
		DO
			I C@
			DUP 20 < OVER 7A > OR
				IF DROP 2E THEN
					EMIT
// BRK					
		LOOP
// BRK
	ELSE
		DROP DROP
THEN
;
FORTH DEFINITIONS 
RUNTIME
: DUMP
		DEPTH 2 < IF
 ABORT" Not enough items on stack "
//		." Not enough items on stack " 
//		CRASH
 THEN
		OVER SWAP				( ADDR ADDR CNT )
		0 DO					( LOOP LEN TIMES )
			I 0F AND NOT
				IF
					SDASC
					CR DUP
					4 U.R
					SWAP DROP DUP
//					KEYHIT IF
//						KEY 1B = IF
//							LEAVE
//						ELSE
//							KEY DROP
//						THEN
//					THEN
				THEN
			DUP C@ 2 U.R
			1+
		LOOP
		SDASC
		DROP DROP
		CR
;

RUNTIME DEFINITIONS
( SAM7 FLASH PROGRAMMING COMMANDS.

01 CONSTANT WP 			( Write page
02 CONSTANT SLB  		( Set Lock Bit 
03 CONSTANT WPL 		(  Write Page and Lock 
04 CONSTANT CLB 		(  Clear Lock Bit 
08 CONSTANT EA 			(  Erase all 
0B CONSTANT SGPB 		(  Set General-purpose NVM Bit
0D CONSTANT CGPB 		(  Clear General-purpose NVM Bit 
0F CONSTANT SSB 		(  Set Security Bit 

( Embedded Flash Controller EFCS User Interface

60 CONSTANT 	MC_FMR	( MC Flash Mode Register
64 CONSTANT 	MC_FCR 	( MC Flash Command Register Write-only 
68 CONSTANT 	MC_FSR 	( MC Flash Status Register

FFFFFF00 CONSTANT MCBASE	( Memory Controller MC User Interface

5A 18 LSHIFT CONSTANT FLASHKEY ( The shifted 24 places (18 hex

30 CONSTANT CPUMHZ ( CPU clock speed )

: READFSTAT 
	[ MCBASE MC_FSR + LITERAL ]
	@
;

: READFMODE 
	[ MCBASE MC_FMR + LITERAL ]
	@
;

: WAITFREADY
	BEGIN
		READFSTAT 1 AND ( WAIT FOR READY )
	UNTIL
;

: CLEARLOCK ( PAGENUM -- MT )
[	CPUMHZ 10 LSHIFT CPUMHZ F LSHIFT + ( = MHZ *1.5 LSFT DEC'16 
	100 + LITERAL ( ADD 1 WAIT STATE
]

	[ MCBASE MC_FMR + LITERAL ]
	!
	8 LSHIFT  ( SHIFT PAGE NUMBER AND BUILD COMMAND)
	[ FLASHKEY CLB + LITERAL ]
	+
	[ MCBASE MC_FCR + LITERAL ]
	!
	WAITFREADY
;

: SETLOCK ( PAGENUM -- MT )
[	CPUMHZ 10 LSHIFT CPUMHZ F LSHIFT + ( = MHZ *1.5 LSFT DEC'16 
	100 + LITERAL ( ADD 1 WAIT STATE
]

	[ MCBASE MC_FMR + LITERAL ]
	!
	8 LSHIFT  ( SHIFT PAGE NUMBER AND BUILD COMMAND)
	[ FLASHKEY SLB + LITERAL ]
	+
	[ MCBASE MC_FCR + LITERAL ]
	!
	WAITFREADY
;

: UNLOCKALL
	0
	BEGIN
	
		DUP 
		6 LSHIFT	( * H'40 {DEC 64} 64 Pages per sector )		
		CLEARLOCK
		1 + DUP
	10 > UNTIL
	DROP
;

: LOCKALL
	0
	BEGIN
	
		DUP 
		6 LSHIFT	( * H'40 {DEC 64} 64 Pages per sector )		
		SETLOCK
		1 + DUP
	10 > UNTIL
	DROP
;

: LOCK64K
	0
	BEGIN
		DUP 
		6 LSHIFT	( * H'40 {DEC 64} 64 Pages per sector )		
		SETLOCK
		1 + DUP
	4 = UNTIL
	DROP
;

: MIRRORPAGE ( PAGENUM OFFSET -- MT
USER !		( Save offset 
[	CPUMHZ 3 * F LSHIFT ( = MHZ  LSFT DEC'16 
	100 + LITERAL ( ADD 1 WAIT STATE
]
	[ MCBASE MC_FMR + LITERAL ]
	!
	
	DUP						( COPY PAGE NUMBER
	8 LSHIFT 				( PAGE NUM TO BYTE ADDRESS
	
	BEGIN
		DUP	 200000 + @			( FETCH FROM RAM WORD ADDRESS 
		OVER 100000 + USER @ + !			( STORE TO FLASH {BUFFER} WORD ADDRESS  
		4 + 
		DUP FF AND
	0= UNTIL
	DROP 
		8 LSHIFT USER @ + ( SHIFT PAGE NUMBER AND BUILD COMMAND)
	[ FLASHKEY WP + LITERAL ]
	+
	[ MCBASE MC_FCR + LITERAL ] 
	!
	WAITFREADY
;

FORTH DEFINITIONS 
RUNTIME

: MIRROR1
	0
	BEGIN
		DUP	
		0 MIRRORPAGE
		1 + 
		DUP 
	FF > UNTIL
	DROP
;

: MIRROR2
	0
	BEGIN
		DUP	
		10000 MIRRORPAGE
		1 + 
		DUP 
	FF > UNTIL
	DROP
;

: RS READFSTAT U. ;

SP! HEX
: EXTRAS ; // Place marker.
COMPILER DEFINITIONS

: ." ( Compile print string.
	22 WORD
	C@ IF
		[ 'LFA [."] LFA>CA LITERAL ] BRLNK (  Make a call to  [."] 
		PAD C@ 1 +
		0
		BEGIN				( CNTDWN INDEX --
			DUP PAD + C@ 	( Get byte from PAD )
			C,				( CNTDWN INDEX --
			1 + SWAP
			1 - SWAP
		OVER 0=	UNTIL
		DROP DROP
		2 ALIGNDP
	THEN
;

IMMEDIATE
FORTH DEFINITIONS

: ." ( interpretive print )
  22 WORD TYPE ;
 
: ALLOT // N -- mt ; Allot N bytes in the dictionary.
	HERE + 2 ALIGN DP !
;

: VARALLOT VARPTR +! ;

: VOCABULARY
	2 ALIGNDP HERE
	CREATE LATEST @ LFA>FFA DUP
	C@ F_VOCB OR SWAP C!
	LRPUSH
	[ ' [VOC] LITERAL ] BRLNK 
//	HERE MARKER !			( SAVE HERE SO WE CAN UNLINK VOC )
	VARPTR @ 
	DUP MARKER !
	DUP ,
	BPW VARPTR +!
	CONTEXT @ SWAP !		( LINK TO CONTEXT DICT )
	HERE VOCLINK @ ,		( LINK TO PREVIOUS VOCAB )
	VOCLINK !				( POINT VOCLINK HERE )
	BPW+ 1+ ,
;

: UNLINKVOCAB
	0 MARKER @ !
;

: ASM ; // Just a place marker 

// the arm can't load load immediate values so we need a way to generate
// lookup table (usually PC referenced. I will us another data stack for 
// storing the value and ldr addresses for later patching - the AUX stack.
( In future stacks may be objects or >BUILDS DOES> constructs

20 CONSTANT AUXSIZE // the size of the aux stack in words.
VARIABLE AUX // reserve space for the stack.
AUXSIZE 2 LSHIFT VARALLOT // Reserve space - it will be size+1 
VARIABLE AUXSP // The stack pointer

: @OR @ OR ;
: OR! 		// NUM ADDR --
	SWAP OVER // ADDR NUM ADDR
	@OR SWAP !
	
;
VOCABULARY ASSEMBLER 
ASSEMBLER DEFINITIONS

: AUX!							// Reset the pointer
	AUX AUXSP !
;
0 'LFA AUX! !
AUX!
: >AUX							// Push a value from Top to aux stack.
	AUXSP @ !
	AUXSP @ [ AUX AUXSIZE 2 LSHIFT + LITERAL ]	
	< IF 
		BPW AUXSP +! 
	ELSE 
		." Aux stack overflow" CR
	THEN
;

: AUX>							// Push a value from aux stack to Top.
	AUXSP @ AUX 
	> IF 
		BPW AUXSP -! 
	ELSE 
		." Aux stack underflow" CR
	THEN
	AUXSP @ @	
;

: AUXDEPTH // -- N ; Aux stack depth in words.
	AUXSP @ AUX - 2 RSHIFT
;
( a register list stack. Could be a byte stack.
10 CONSTANT REGSSIZE // the size of the aux stack in words.
VARIABLE REGS // reserve space for the stack.
REGSSIZE 2 LSHIFT VARALLOT // Reserve space - it will be size+1 
VARIABLE REGSSP // The stack pointer

: REGS!							// Reset the pointer
	REGS REGSSP !
;
REGS!

: >REGS							// Push a value from Top to aux stack.
	REGSSP @ !
	REGSSP @ [ REGS REGSSIZE 2 LSHIFT + LITERAL ]	
	< IF 
		BPW REGSSP +! 
	ELSE 
		." Reg stack overflow" CR
	THEN
;

: REGS>							// Push a value from aux stack to Top.
	REGSSP @ REGS 
	> IF 
		BPW REGSSP -! 
	ELSE 
		." Reg stack underflow" CR
	THEN
	REGSSP @ @	
;

: REGSDEPTH // -- N ; Aux stack depth in words.
	REGSSP @ REGS - 2 RSHIFT
;

VARIABLE REGMASK	( A place to build regist list field for LDM etc.
VARIABLE CODEBITS
VARIABLE IMMVAL
VARIABLE IMMSHT
VARIABLE CFLAGS
1 CONSTANT SFLAG
2 CONSTANT IMMDFLAG
4 CONSTANT SBZFLAG
: R0	( FOR ASM )
	0 >REGS
;

: R1	( FOR ASM )
	1 >REGS
;
: R2	( FOR ASM )
	2 >REGS
;
: R3	( FOR ASM )
	3 >REGS
;
: R4	( FOR ASM )
	4 >REGS
;
: R5	( FOR ASM )
	5 >REGS
;
: R6	( FOR ASM )
	6 >REGS
;
: R7	( FOR ASM )
	7 >REGS
;
: R8	( FOR ASM )
	8 >REGS
;
: R9	( FOR ASM )
	9 >REGS
;
: R10	( FOR ASM )
	0A >REGS
;
: R11	( FOR ASM )
	0B >REGS
;
: R12	( FOR ASM )
	0C >REGS
;
: R13	( FOR ASM )
	0D >REGS
;
: R14	( FOR ASM )
	0E >REGS
;
: R15	( FOR ASM )
	0F >REGS
;

: SP R13 ;
: LR R14 ;
: PC R15 ;

: REGS>MASK
	0 REGMASK !
	BEGIN
		REGSDEPTH
	WHILE
		REGMASK @
		1
		REGS>
		LSHIFT
		+ REGMASK ! ( Should be "OR" but we don't have it)
	REPEAT
;


: [P] // Set the P bit in PUxWL type codes.
	1000000 CODEBITS OR!
;

: [U] // Set the 	U bit in PUxWL type codes.
	800000 CODEBITS OR!
;
// Note that there are 2 type of "S" flag sometime is means "status" sometimes "sign"
// the former changes position eg bit 22 is LDM and bit 20 in data processing inst.
: [S] // Set the S bit in PUxWL type codes.
	SFLAG CFLAGS OR!
;

: [!] // Set the W bit in PUxWL type codes.
	200000 CODEBITS OR!
;

VARIABLE CCODES // condition codes
: CCODES! CCODES ! ;
: EQ 
	0 CCODES!
;

: NE 
	10000000 CCODES!
;

: CS 
	20000000 CCODES!
;

: HS 
	20000000 CCODES!
;

: LO 
	30000000 CCODES!
;

: CC 
	30000000 CCODES!
;

: MI 
	40000000 CCODES!
;

: PL 
	50000000 CCODES!
;

: VS 
	60000000 CCODES!
;

: VC 
	70000000 CCODES!
;

: HI 
	80000000 CCODES!
;

: LS 
	90000000 CCODES!
;

: GE 
	A0000000 CCODES!
;

: LT 
	B0000000 CCODES!
;

: GT 
	C0000000 CCODES!
;

: LE 
	D0000000 CCODES!
;

: AL 
	E0000000 CCODES!
;

: NV 
	F0000000 CCODES!
;

: { // clear register list for { reglist } type syntax
	REGS! AL
	0 CODEBITS 	!
	0 IMMVAL	!
	0 IMMSHT 	!
	0 CFLAGS 	!
;

: } // Make mask for { reglist } type syntax
	REGS>MASK
;

: PUxWL // Make code for instructions multiple load/store 
	REGSDEPTH 0= IF SP THEN // If no reg on stack assume SP
	REGS> 10 LSHIFT + // fill in reg field.
	CODEBITS @ +
	CFLAGS @ SFLAG AND IF 400000 CODEBITS OR! THEN
	CCODES @ +
	REGMASK @ + 
	,
	{	// Clear for next instruction.
;

: LDM,	// Load multiple
	8100000 PUxWL
;

: STM,	// Store multiple
	8000000 PUxWL
;

: PUSH 
	[P] [!] STM,
;

: POP 
	[U] [!] LDM,
;


: LFA>FFA // Convert the link address to flag address
	4 + 
;

1	CONSTANT F_IMMD		( immediate flag )
2	CONSTANT F_OFFS		( offset compilation flag ie dA non-zero )
4	CONSTANT F_REMT		( remote flag ie headerless code or alias )
8	CONSTANT F_SMUD		( smudge flag )
10	CONSTANT F_VOCB  	( vocab flag )
20 	CONSTANT F_THUMB 

100 CONSTANT COMPFLAG

F_SMUD CONSTANT F_XCOMP

: NATIVE 0 MODE ! ;

: XCOMPMODE F_XCOMP MODE ! ;

'LFA CREATE LFA>CA // Remember CA of existing CREATE
FORTH DEFINITIONS
ASSEMBLER

: CREATE // A new version of create which has more flag options.
	2 ALIGNDP HERE LFA>FFA // remember FFA - at compile time not meta complile time.
	[ COMPILER BRLNK ] // Make a call to the old version of CREATE 
	MODE C@ SWAP C! // Overwrite the flags
	2 ALIGNDP
;

: CODE 
CREATE { AUX! ASSEMBLER
;

ASSEMBLER DEFINITIONS

: END-CODE 
	BEGIN
		AUXDEPTH
	WHILE
		AUX> 	
		AUX>					// NUM *INST 		-- Get address of inst to patch.
		DUP	HERE SWAP 8 + -	FFF AND	// NUM *INST OFFS 	-- Make rel offset
		OVER @OR				// NUM *INST MERG 	-- Merge with instruction
		SWAP !					// NUM
		,
	REPEAT
	ASSEMBLER VDROP
;

: BR24, // Make code for instructions such as BR,BL
	CODEBITS @ +
	CCODES @ +
	SWAP HERE 8 + - 2 RSHIFT
	FFFFFF AND +
	,
	{	// Clear for next instruction.
;

: BR1 
	A000000 BR24,
;

: BRLNK1 
	B000000 BR24,
;

: NEGATE, 
	0 SWAP -
;

: ALIGN, 			// REMOVE? Align address on stack - use ALIGN, to align DP
	1 				( Build mask etc. -- N 1
	BEGIN
		SWAP 2*
		SWAP 1 -
		DUP 
	0=	UNTIL
	DROP 		// ADDR MASK -- 
	SWAP OVER 1 - +	// MASK {ADDR+MASK-1} -- 
	SWAP NEGATE, AND 
;

: GOTO, 
	'LFA LFA>CA 2 ALIGN, BR1
;

: CALL, 
	'LFA LFA>CA 2 ALIGN, BRLNK1
;

: BRDR 				// get base and dest regs from stack to mask
	0 REGMASK !
	REGSDEPTH IF	
		REGS>		// Get dst
	ELSE 
		0 ." No regs???" CR // error 
	THEN
	REGSDEPTH IF	
		REGS>		// get base
	ELSE
		DUP			// no base - make same as dest
	THEN			// dest base -- 
	CODEBITS @ // Is it a load or a store 
	[ 1 14 LSHIFT LITERAL ] AND
	IF SWAP THEN
	0C LSHIFT REGMASK OR!
	10 LSHIFT REGMASK OR!
	REGSDEPTH IF	// If there is a register left it must be for offset
		REGS>		// get offset reg
		REGMASK OR!
		2000000 CODEBITS OR!
		IMMSHT @ CODEBITS OR!
	ELSE 			// Might need offset12 or offset8
		IMMVAL @ IF 
			IMMVAL @ DUP
			0 < IF
				NEGATE,
			ELSE
				[U]
			THEN
			CODEBITS @ 2000000 AND IF // if zero it's a 8 bit offset 
				FF AND DUP
				F AND SWAP
				F0 AND 4 LSHIFT +
			ELSE
				FFF AND
			THEN
			CODEBITS OR!
		THEN
	THEN
;	
.S RP@ . HERE . 
: # 
	IMMVAL !
	IMMDFLAG CFLAGS OR!
;

: MAKESFT
	CFLAGS @ IMMDFLAG AND 
	IF
		IMMVAL @ 1F AND 7 LSHIFT + IMMSHT !
		CFLAGS @ IMMDFLAG - CFLAGS !
		0 IMMVAL !		
	ELSE
		10 + IMMSHT !
		REGS>
		8 LSHIFT
		CODEBITS OR!


	THEN
	
;

: LSL 
	0 MAKESFT 
;

: LSR 
	[ 1 5 LSHIFT LITERAL ] 
	MAKESFT
;

: ASR 
	[ 2 5 LSHIFT  LITERAL ]
	MAKESFT
;

: ROR 
	[ 3 5 LSHIFT  LITERAL ] 
	MAKESFT
;

: RRX // NB. the previous 4 words assume a value on the data stack, rxx doesn't
	[ 3 5 LSHIFT LITERAL ]  IMMSHT !
;

: LDSTWB 			// Make code for instructions such as load/store 
	CODEBITS OR!
	BRDR
	CODEBITS @ 
	CCODES @OR
	REGMASK @OR
	IMMSHT @OR
	,
	{				// Clear for next instruction.
;

// UBYTE AND WORD
: STR,
	4000000 LDSTWB
;

: LDR,
	4100000 LDSTWB
;

: STRB,
	4400000 LDSTWB
;

: LDRB,
	4500000 LDSTWB
;

// SBYTE AND HWORD

: STRSB,
	D0 LDSTWB
;

: LDRSB,
	1000D0 LDSTWB
;
: STRSH,
	F0 LDSTWB
;

: LDRSH,
	1000F0 LDSTWB
;
: STRH,
	B0 LDSTWB
;

: LDRH,
	1000B0 LDSTWB
;

: SHIFTOP // Work out shift field and status bit 
	CFLAGS @ SFLAG AND IF
	[ 1 14 LSHIFT LITERAL ] OR
	THEN
	CFLAGS @ IMMDFLAG AND 
	IF								// The immediate flag is set - try to make a immd shift.
		IMMVAL @ 0					// VAL SFT -- ; get the immediate value 
		0 USER !					// flag as not done
		BEGIN	
			USER @ 0=
		WHILE						// VAL SFT
			DUP C <
			IF 
				SWAP DUP FFFFFF00 AND 0= 		// 
				IF 
					1 USER !		// -- SFT VAL ; Still swapped
				ELSE
					DUP 1 AND 0= IF
						2 RSHIFT
						SWAP 1 +
					ELSE
						2 USER !
					THEN
				THEN
			ELSE					// 
				3 USER !
			THEN
		REPEAT						// val sht -- or -- sht val ; 
		USER @ 1 = IF
			SWAP
			10 SWAP - F AND
			8 LSHIFT +
			2000000 OR			
			CODEBITS OR!
			1						// TRUE --
		ELSE
			DROP DROP 0				// FALSE -- 
		THEN
	ELSE		// Not immediate mode.
	1
	THEN	
;

:	MOVINST	
	CODEBITS @OR
	IMMSHT @OR
	REGS> C LSHIFT OR
	REGSDEPTH IF
		REGS> 
	ELSE
		2000000
	THEN
	OR
	,	
	{				// Clear for next instruction.
;

: ERROR ." range error " CR ;

: MOV,	
[ D 15 LSHIFT LITERAL ]
	CCODES @ +

	SHIFTOP
	IF MOVINST
	ELSE
		DROP
		HERE >AUX
		IMMVAL @ >AUX
		0 IMMVAL !
		REGS> PC >REGS [U] [P] LDR,
	THEN
;

: MVN,	
[ F 15 LSHIFT LITERAL ]
	CCODES @ +

    SHIFTOP 
	IF MOVINST
	ELSE DROP ERROR
	THEN
;

: CHKSBZ CFLAGS @ SBZFLAG AND ;

 : COMP	
	CFLAGS @ SFLAG AND IF 100000 OR THEN
	CCODES @ +
    SHIFTOP 
	IF 
		CODEBITS @OR

		REGS> 
		REGSDEPTH IF 
			REGS>
		ELSE
			CHKSBZ
			IF 0 SWAP		// The RD field for this instruction should be zeroed.
			ELSE DUP
			THEN
		THEN
 		
		CHKSBZ		// If sbz bit clear shift to RD position
			IF	
				CFLAGS @ IMMDFLAG AND NOT IF SWAP THEN	
				10 LSHIFT
			
			ELSE
				10 LSHIFT
				SWAP	
				C LSHIFT
			THEN 
		OR OR
		REGSDEPTH IF
			REGS> OR
		THEN
	,	
	ELSE
		DROP ERROR
	THEN
	{				// Clear for next instruction.
;

: [SBZ] // Set the "SHOULD BE ZERO" flag.
	SBZFLAG CFLAGS OR!
;

: AND, [ 0 15 LSHIFT LITERAL ]  COMP ;
: EOR, [ 1 15 LSHIFT LITERAL ]  COMP ;
: SUB, [ 2 15 LSHIFT LITERAL ]  COMP ;
: RSB, [ 3 15 LSHIFT LITERAL ]  COMP ;
: ADD, [ 4 15 LSHIFT LITERAL ]  COMP ;
: ADC, [ 5 15 LSHIFT LITERAL ]  COMP ;
: SBC, [ 6 15 LSHIFT LITERAL ]  COMP ;
: RSC, [ 7 15 LSHIFT LITERAL ]  COMP ;
: TST, [ 8 15 LSHIFT LITERAL ] [S] [SBZ] COMP ;
: TEQ, [ 9 15 LSHIFT LITERAL ] [S] [SBZ] COMP ;
: CMP, [ A 15 LSHIFT LITERAL ] [S] [SBZ] COMP ;
: CMN, [ B 15 LSHIFT LITERAL ] [S] [SBZ] COMP ;
: ORR, [ C 15 LSHIFT LITERAL ]  COMP ;
: BIC, [ E 15 LSHIFT LITERAL ]  COMP ;

: CLZ,
	016F0F10
	CCODES @ +
	REGS> C LSHIFT OR
	REGS> OR
	,
	{
;

: MUL,
	90
	CCODES @ +
	REGS> 				// Get RD
	REGSDEPTH 2 < IF  	// if less than 2 regs on stack dup 
		DUP
	ELSE 
		REGS>
	THEN
	8 LSHIFT
	SWAP 10 LSHIFT OR OR	// Add RS
	REGS> OR			// Add RM
	,
	{
;

: .I HERE 4 - U? ;

: BEGIN,
	HERE
;

: FLIPCC
	CCODES @ 10000000 XOR CCODES!
;

: UNTIL, 
	FLIPCC BR1
;

: AGAIN, NV UNTIL, ;

: IF,
	HERE // Remember here
	DUP FLIPCC BR1 // Make dummy branch to be patched later.
;

: THEN, 						// addr -- ; top has address to be patched
	DUP 						// ADDR ADDR -- DUP PATCH ADDRESS
	 8 + HERE SWAP - 2 RSHIFT	// ADDR OFFSET -- 
	FFFFFF AND 					// ADDR OFFSET24 -- 
	OVER @ FF000000 AND + 
	SWAP !
;

: ELSE,			// Else is like a "then" with an uncoditional branch left for patching.
	HERE 
	DUP BR1 // The default is "AL" 
	SWAP THEN, 	
;

: WHILE,
	IF,			// While is like IF,
;

: REPEAT,		// Baddr WADDR -- ; address of begin and while on top.
	SWAP BR1		// Make a branch back to BEGIN
	THEN,		// Use "then" to patch forward
;

: SPSR	( FOR ASM )
	10 >REGS
;

: CPSR	( FOR ASM )
	11 >REGS
;

: MRS, 
	010F0000
	CCODES @OR
	REGS> 
	C LSHIFT OR
	REGS>
	10 = IF 400000 OR THEN	// SPSR OR CPSR
	,
	{				// Clear for next instruction.
;

: _C 10000 CODEBITS OR! ;
: _X 20000 CODEBITS OR! ;
: _S 40000 CODEBITS OR! ;
: _F 80000 CODEBITS OR! ;

: MSR, 
	0120F000
	CCODES @OR
	REGS>
	10 = IF 400000 OR THEN	// SPSR OR CPSR
	    SHIFTOP 
	IF 
		REGSDEPTH IF REGS> OR THEN
		CODEBITS @OR
		,
	ELSE ERROR
	THEN
	{
;

: RMP R9 ;
: ROP  R8 ;
: RDSP R7 ;
: RTOP R6 ;
// : RSEC R5 ;
RUNTIME 
COMPILER DEFINITIONS
: @
	E4166000 , // RTOP RTOP LDR, 
	;
IMMEDIATE
: C@
	E4566000 , // RTOP RTOP LDRB, 
;
IMMEDIATE
: DUP
	E4A76004 ,
;
IMMEDIATE	
	
: 1+ 
	E2866001 , // 1 # RTOP ADD, 
;
IMMEDIATE	

: 1- 
	E2466001 , // 1 # RTOP SUB, 
;
IMMEDIATE	
	
: 2* 
	E1A06086 , // RTOP 1 # LSL RTOP MOV,
;
IMMEDIATE

: 2/ 
	E1A060A6 , // RTOP 1 # LSR RTOP MOV,
;
IMMEDIATE

: NEGATE 
	E2666000 , // 0 # RTOP RTOP RSB,
;
IMMEDIATE

: INVERT 
	E1E06006 , // RTOP RTOP MVN, 
;
IMMEDIATE
	
FORTH DEFINITIONS
RUNTIME
ALIAS AGAIN AGAIN,
IMMEDIATE


FORTH DEFINITIONS
: WITHIN ( N1 N2 N3 -- T/F ; is N1 within the range N2 - N3 inclusive )
  OVER OVER < IF SWAP THEN  ( N1 H L -- put lower limit on top )
  ROT SWAP OVER             ( H N1 L N1 -- )
  > >R                      ( H N1 -- )
  < R> OR NOT               ( T/F )
;

: PATCHBRLNK			// Insert a branch too *NXT at address @ top
	HERE SWAP ( Save DP for later
	DP !		( Move dp to patch address
	SWAP BRLNK		( Apply the patch
	DP !		( Restore dp 
;

( a "<BUILDS DOES>" data type has the following layout )
( the creator )
( NAME, <BUILDS BRLNK , COMPILE TIME FORTH , INLINE DOES CODE , RUNTIME FORTH ; )
( the data instance )
( NAME , LRPUSH, BRNLK TO INLINE CODE , DATA )

: <BUILDS // called when the creator is called. 
	CREATE LRPUSH
	HERE MARKER !
	0 ,			( RESERVE SPACE FOR DOES> ADDR )
;
 ASSEMBLER
: [DOES] 
	R> MARKER @ PATCHBRLNK 
;
COMPILER DEFINITIONS
: DOES> // called when the creator is COMPILED. 
	[ ' [DOES] LITERAL ] BRLNK
	{ AUX!
	4 # RTOP [!] RDSP STR, 	// push sec to memory stack
	LR RTOP MOV,			// LR has address of r/t code pointer
//	BPW # RTOP ADD,			// the next word is data - bld/does data addr to top
//	MODE@ 2 = IF
//		 BPW OP +!
//	THEN

;

IMMEDIATE

FORTH DEFINITIONS

// Type MIRROR64K to save image to flash, may need UNLOCKALL first.

 FORGET EXTRA

: EXTRA ;
SP!
FORTHONLY
FORTH DEFINITIONS
RUNTIME
HEX 

: 'IMMEDIATE	// unlike IMMEDIATE  - This finds a word and MARKS it.
	'LFA LFA>FFA F_IMMD OVER C@ OR SWAP C!
;
: IMMED LATEST @ BPW + F_IMMD OVER C@ OR SWAP C! ;

COMPILER DEFINITIONS

FORTH DEFINITIONS
VOCABULARY MESSAGES UNLINKVOCAB
VARIABLE LSTMSG

: LFA>MSG
	4 + 1 + DUP C@ + 9 + 2 ALIGN
;	

: MSGTYPE	( MSGNO. -- EMPTY )
MESSAGES CONTEXT
 @	( MSGNO. LINK --> )
BEGIN
	DUP
WHILE
	OVER OVER  ( MSGNO. LINK MSGNO. LINK --> )
	LFA>MSG @ = IF
			BPW + 1+
			TYPE DROP
			EXIT
	THEN
	@
REPEAT
DROP DROP
;

: UNKNMSG
	." Message No. " DUP U. MSGTYPE SPACE
	ABORT" NOT UNDERSTOOD ??? "
;

: REDEFINED?
>IN @ 20 WORD C@
IF MESSAGES FIND
	 IF ." Warning '" PAD TYPE DROP ." ' redefined " CR
	 THEN
THEN
>IN !
;

8000 LSTMSG !   ( Local message start at no. 8000h )
RUNTIME DEFINITIONS

CODE [MSGLITERAL]	
	4 # [!] LR R0 LDR,
	R0 4 # RMP [!] STR,
	LR PC MOV,							// mov 	pc,lr	
END-CODE

FORTH DEFINITIONS

CODE >M
	RTOP 4 # RMP [!] STR,
	-4 # RDSP [P] [!] RTOP LDR,
	LR PC MOV,	
END-CODE

CODE M>
	RTOP 4 # RDSP [!] STR,
	-4 # RMP [P] [!] RTOP LDR,
	LR PC MOV,	
END-CODE

CODE MDROP
	4 # RMP SUB,
	LR PC MOV,	
END-CODE

ASSEMBLER
: GMESSAGE
 REDEFINED?
 <BUILDS IMMED						( BUILD MESSAGE HEADER ETC )
	,								( save message value )
	DOES>
	@
	MODE @ IF
		DUP [ ' [MSGLITERAL] LITERAL ] BRLNK , // REMEMBER TO PATCH.
	THEN
	>M								// THIS DOESN'T LOOK RIGHT CHECK WHEN OO DEFINED
;

: MESSAGE
	LSTMSG @ 1+ DUP LSTMSG !
	GMESSAGE
;

// HIDE REDEFINED?

// INCLUDE GMESSAGE.FOR
 MESSAGES DEFINITIONS
( global messages )
( VDU OUTPUT MESSAGES )
1 GMESSAGE emit
2 GMESSAGE type
3 GMESSAGE cr	// Not implimented in server
( KEYBOARD IO MESSAGES )
100 GMESSAGE getline
101 GMESSAGE key
102 GMESSAGE getnumber
103 GMESSAGE hit
( FILE IO MESSAGES )
1001 GMESSAGE	open
1002 GMESSAGE	close
1003 GMESSAGE	append
1004 GMESSAGE	read
1005 GMESSAGE	write
1006 GMESSAGE	eof
( MISC PARAMETERS )
1800 GMESSAGE  real32
1801 GMESSAGE  int32
( MISC MESSAGES )
2001 GMESSAGE   error

FORTH DEFINITIONS

: 2C, DUP C, 8 RSHIFT C, ;
ALIAS LLHH 2C,

COMPILER DEFINITIONS

: [COMPILE]
	' BRLNK
;
FORTH DEFINITIONS
IMMEDIATE
: IFDO
	NOT IF [COMPILE] ( THEN
;
: HIDE 0 'LFA 5 + 20 OVER 1+ C! C! ;
: SET2SERV
	[ ' SERVCR LITERAL ] *PUTLINE !
	[ ' SERVGETLINE LITERAL ] *GETLINE !
;

: SET2DUMB
	[ ' DUMBCR LITERAL ] *PUTLINE !
	[ ' GETSERLN LITERAL ] *GETLINE !
;


: -DS
	FLASHLED
	SET2DUMB
	." Hit any key to run dumb term mode " CR
	20000 TSIN
	0 > IF ABORT EXIT THEN
	SET2SERV
	PINGSERV
	IF ABORT EXIT THEN	
;

: DETECTSERV 
INIT
BLK@ IF BLK@ 4 + CLOSEFP THEN
CONFIGURE
BEGIN
	BASE_US0 *USART !
	-DS
	BASE_US1 *USART !
	-DS	
AGAIN
;
 HERE 1000 ERASE
 ' DETECTSERV *COLD ! // Patch abort address

." BUILD COMPLETE " HERE . CR

DETECTSERV


ABORT